MindWrtParser Class Reference documentation

MindWrtParser Class Referencefinal

the main class to read a MindWrite file More...

`#include <MindWrtParser.hxx>`

Inheritance diagram for MindWrtParser:

## Public Member Functions
| MindWrtParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~MindWrtParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
bool | sendZone (int i)
| try to send a zone
bool | readGraphic (MindWrtParserInternal::LineInfo const &line)
| try to read a graphic
bool | readRuler (MindWrtParserInternal::LineInfo &line)
| try to read a ruler
bool | readCompressedText (MindWrtParserInternal::LineInfo const &line)
| try to read a compressed text zone
bool | readText (MindWrtParserInternal::LineInfo const &line)
| try to read a non compressed text zone
void | sendText (std::string const &text, std::vector< MWAWFont > const &fonts, std::vector< int > const &textPos)
| try to send the text
void | sendHeaderFooter (bool header)
| try to send the header/footer zone
void | sendHeaderFooterFields (bool header)
| try to send the header/footer fields as text (in a textbox)
bool | readFonts (MWAWEntry const &entry, std::vector< MWAWFont > &fonts, std::vector< int > &textPos)
| try to read the fonts
bool | readPrintInfo (MWAWEntry const &entry)
| read the print info zone
bool | readLinesInfo (MWAWEntry &entry)
| read the lines information zone
bool | readLastZone (MWAWEntry const &entry)
| read the last zone ( pos + 7fffffff )
bool | readZone8 (MWAWEntry &entry)
| read the 8th zone ( unknown zone)
bool | readHeadingStates (MWAWEntry &entry)
| read the heading state
bool | readHeadingFields (MWAWEntry &entry)
| read the heading field zone ( zone 12 )
bool | readHeadingProperties (MWAWEntry &entry)
| read the heading property zone
bool | readHeadingCustom (MWAWEntry &entry)
| read the heading custom zone
void | setProperty (MWAWParagraph const &para)
| sends a paragraph property to the listener
void | newPage (int number)
| adds a new page
MWAWEntry | readEntry ()
| read a file entry
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< MindWrtParserInternal::State > | m_state
| the state

## Friends
class | MindWrtParserInternal::SubDocument

## Detailed Description

the main class to read a MindWrite file

## Constructor & Destructor Documentation

## ◆ MindWrtParser()

MindWrtParser::MindWrtParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~MindWrtParser()

MindWrtParser::~MindWrtParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool MindWrtParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by MindWrtParserInternal::SubDocument, and parse().

## ◆ createDocument()

void MindWrtParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by MindWrtParserInternal::SubDocument, and parse().

## ◆ createZones()

bool MindWrtParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by MindWrtParserInternal::SubDocument, and parse().

## ◆ init()

void MindWrtParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by MindWrtParser(), and MindWrtParserInternal::SubDocument.

## ◆ newPage()

void MindWrtParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by MindWrtParserInternal::SubDocument, and sendZone().

## ◆ parse()

void MindWrtParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by MindWrtParserInternal::SubDocument.

## ◆ readCompressedText()

bool MindWrtParser::readCompressedText | ( | MindWrtParserInternal::LineInfo const & | line | ) |
| protected

try to read a compressed text zone

Referenced by MindWrtParserInternal::SubDocument, and sendZone().

## ◆ readEntry()

MWAWEntry MindWrtParser::readEntry | ( |  | ) |
| protected

read a file entry

Referenced by createZones(), and MindWrtParserInternal::SubDocument.

## ◆ readFonts()

bool MindWrtParser::readFonts | ( | MWAWEntry const & | entry,
|  | std::vector< MWAWFont > & | fonts,
|  | std::vector< int > & | textPos )
| protected

try to read the fonts

Referenced by MindWrtParserInternal::SubDocument, readCompressedText(), and readText().

## ◆ readGraphic()

bool MindWrtParser::readGraphic | ( | MindWrtParserInternal::LineInfo const & | line | ) |
| protected

try to read a graphic

Referenced by MindWrtParserInternal::SubDocument, and sendZone().

## ◆ readHeadingCustom()

bool MindWrtParser::readHeadingCustom | ( | MWAWEntry & | entry | ) |
| protected

read the heading custom zone

Referenced by createZones(), and MindWrtParserInternal::SubDocument.

## ◆ readHeadingFields()

bool MindWrtParser::readHeadingFields | ( | MWAWEntry & | entry | ) |
| protected

read the heading field zone ( zone 12 )

Referenced by createZones(), and MindWrtParserInternal::SubDocument.

## ◆ readHeadingProperties()

bool MindWrtParser::readHeadingProperties | ( | MWAWEntry & | entry | ) |
| protected

read the heading property zone

Referenced by createZones(), and MindWrtParserInternal::SubDocument.

## ◆ readHeadingStates()

bool MindWrtParser::readHeadingStates | ( | MWAWEntry & | entry | ) |
| protected

read the heading state

Referenced by createZones(), and MindWrtParserInternal::SubDocument.

## ◆ readLastZone()

bool MindWrtParser::readLastZone | ( | MWAWEntry const & | entry | ) |
| protected

read the last zone ( pos + 7fffffff )

Referenced by createZones(), and MindWrtParserInternal::SubDocument.

## ◆ readLinesInfo()

bool MindWrtParser::readLinesInfo | ( | MWAWEntry & | entry | ) |
| protected

read the lines information zone

01[45]0

Referenced by createZones(), and MindWrtParserInternal::SubDocument.

## ◆ readPrintInfo()

bool MindWrtParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |
| protected

read the print info zone

Referenced by createZones(), and MindWrtParserInternal::SubDocument.

## ◆ readRuler()

bool MindWrtParser::readRuler | ( | MindWrtParserInternal::LineInfo & | line | ) |
| protected

try to read a ruler

Referenced by MindWrtParserInternal::SubDocument, and readLinesInfo().

## ◆ readText()

bool MindWrtParser::readText | ( | MindWrtParserInternal::LineInfo const & | line | ) |
| protected

try to read a non compressed text zone

Referenced by MindWrtParserInternal::SubDocument, and sendZone().

## ◆ readZone8()

bool MindWrtParser::readZone8 | ( | MWAWEntry & | entry | ) |
| protected

read the 8th zone ( unknown zone)

Referenced by createZones(), and MindWrtParserInternal::SubDocument.

## ◆ sendHeaderFooter()

void MindWrtParser::sendHeaderFooter | ( | bool | header | ) |
| protected

try to send the header/footer zone

field are separated from the main text -> we need to use an intermediate frame

Referenced by MindWrtParserInternal::SubDocument.

## ◆ sendHeaderFooterFields()

void MindWrtParser::sendHeaderFooterFields | ( | bool | header | ) |
| protected

try to send the header/footer fields as text (in a textbox)

Referenced by MindWrtParserInternal::SubDocument.

## ◆ sendText()

void MindWrtParser::sendText | ( | std::string const & | text,
|  | std::vector< MWAWFont > const & | fonts,
|  | std::vector< int > const & | textPos )
| protected

try to send the text

Referenced by MindWrtParserInternal::SubDocument, readCompressedText(), and readText().

## ◆ sendZone()

bool MindWrtParser::sendZone | ( | int | i | ) |
| protected

try to send a zone

Referenced by MindWrtParserInternal::SubDocument, parse(), and sendHeaderFooter().

## ◆ setProperty()

void MindWrtParser::setProperty | ( | MWAWParagraph const & | para | ) |
| protected

sends a paragraph property to the listener

Referenced by MindWrtParserInternal::SubDocument, and sendZone().

## Friends And Related Symbol Documentation

## ◆ MindWrtParserInternal::SubDocument

friend class MindWrtParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<MindWrtParserInternal::State> MindWrtParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), MindWrtParser(), newPage(), parse(), readCompressedText(), readHeadingCustom(), readHeadingFields(), readHeadingProperties(), readLinesInfo(), readZone8(), sendHeaderFooter(), sendHeaderFooterFields(), and sendZone().

The documentation for this class was generated from the following files:

- MindWrtParser.hxx
- MindWrtParser.cxx